#include "hive.h"
#include "vanillahive.h"

#include "bee.h"
#include "cell.h"

VanillaHive::VanillaHive( int w, int h )
:Hive( w, h )
{
	if ( !w ) w = 100;
	if ( !h ) h = 100;
	for ( int a = 0 ; a < 50 ; a++ )
	{
		Cell* cell = new Cell();
		cells.append( cell );
		cell->setRad( 10 + rand() % 10 );
		cell->setCharge( 3 );
		switch ( a % 4 )
		{
		case 0:
			cell->setPos( -40, rand() % h );
			break;
		case 1:
			cell->setPos( w + 40, rand() % h );
			break;
		case 2:
			cell->setPos( rand() % w, -40 );
			break;
		case 3:
			cell->setPos( rand() % w, h + 40 );
			break;
		}
	}
	for ( int a = 0 ; a < 173 ; a++ )
	{
		Bee* bee = new Bee( this );
		allbees.append( bee );
		switch ( a % 4 )
		{
		case 0:
			bee->setPos( -40, rand() % h );
			break;
		case 1:
			bee->setPos( w + 40, rand() % h );
			break;
		case 2:
			bee->setPos( rand() % w, -40 );
			break;
		case 3:
			bee->setPos( rand() % w, h + 40 );
			break;
		}
	}
	b = c = 0;
}

VanillaHive::~VanillaHive(void)
{
}

void VanillaHive::doEvent()
{
	allbees.at(b++)->setTargetCell(cells.at(c++));
	b %= allbees.size();
	c %= cells.size();
}
